wayland::server::zwp_linux_dmabuf_feedback_v1_t(3)

NAME
wayland::server::zwp_linux_dmabuf_feedback_v1_t - dmabuf feedback

SYNOPSIS

#include <wayland-server-protocol-unstable.hpp>

  Public Member Functions

std::function< void()> & on_destroy ()
destroy the feedback object
void done (bool post=true)
all feedback has been sent
void format_table (int fd, uint32_t size, bool post=true)
format and modifier table
void main_device (array_t const &device, bool post=true)
preferred main device
void tranche_done (bool post=true)
a preference tranche has been sent
void tranche_target_device (array_t const &device, bool post=true)
target device
void tranche_formats (array_t const &indices, bool post=true)
supported buffer format modifier
void tranche_flags (zwp_linux_dmabuf_feedback_v1_tranche_flags const &flags, bool post=true)
tranche flags
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t done_since_version = 1
Minimum protocol version required for the done function.
static constexpr std::uint32_t format_table_since_version = 1
Minimum protocol version required for the format_table function.
static constexpr std::uint32_t main_device_since_version = 1
Minimum protocol version required for the main_device function.
static constexpr std::uint32_t tranche_done_since_version = 1
Minimum protocol version required for the tranche_done function.
static constexpr std::uint32_t tranche_target_device_since_version = 1
Minimum protocol version required for the tranche_target_device function.
static constexpr std::uint32_t tranche_formats_since_version = 1
Minimum protocol version required for the tranche_formats function.
static constexpr std::uint32_t tranche_flags_since_version = 1
Minimum protocol version required for the tranche_flags function.

Detailed Description

dmabuf feedback

This object advertises dmabuf parameters feedback. This includes the preferred devices and the supported formats/modifiers.

The parameters are sent once when this object is created and whenever they change. The done event is always sent once after all parameters have been sent. When a single parameter changes, all parameters are re-sent by the compositor.

Compositors can re-send the parameters when the current client buffer allocations are sub-optimal. Compositors should not re-send the parameters if re-allocating the buffers would not result in a more optimal configuration. In particular, compositors should avoid sending the exact same parameters multiple times in a row.

The tranche_target_device and tranche_modifier events are grouped by tranches of preference. For each tranche, a tranche_target_device, one tranche_flags and one or more tranche_modifier events are sent, followed by a tranche_done event finishing the list. The tranches are sent in descending order of preference. All formats and modifiers in the same tranche have the same preference.

To send parameters, the compositor sends one main_device event, tranches (each consisting of one tranche_target_device event, one tranche_flags event, tranche_modifier events and then a tranche_done event), then one done event.

Definition at line 2097 of file wayland-server-protocol-unstable.hpp.

Member Function Documentation

  void zwp_linux_dmabuf_feedback_v1_t::done (bool post = true)

all feedback has been sent This event is sent after all parameters of a wp_linux_dmabuf_feedback object have been sent.

This allows changes to the wp_linux_dmabuf_feedback parameters to be seen as atomic, even if they happen via multiple events.

Definition at line 5130 of file wayland-server-protocol-unstable.cpp.

  void zwp_linux_dmabuf_feedback_v1_t::format_table (int fd, uint32_t size, bool post = true)

format and modifier table

Parameters
    fd table file descriptor
    size table size, in bytes

This event provides a file descriptor which can be memory-mapped to access the format and modifier table.

The table contains a tightly packed array of consecutive format + modifier pairs. Each pair is 16 bytes wide. It contains a format as a 32-bit unsigned integer, followed by 4 bytes of unused padding, and a modifier as a 64-bit unsigned integer. The native endianness is used.

The client must map the file descriptor in read-only private mode.

Compositors are not allowed to mutate the table file contents once this event has been sent. Instead, compositors must create a new, separate table file and re-send feedback parameters. Compositors are allowed to store duplicate format + modifier pairs in the table.

Definition at line 5135 of file wayland-server-protocol-unstable.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  void zwp_linux_dmabuf_feedback_v1_t::main_device (array_t const & device, bool post = true)

preferred main device

Parameters
    device device dev_t value

This event advertises the main device that the server prefers to use when direct scan-out to the target device isn't possible. The advertised main device may be different for each wp_linux_dmabuf_feedback object, and may change over time.

There is exactly one main device. The compositor must send at least one preference tranche with tranche_target_device equal to main_device.

Clients need to create buffers that the main device can import and read from, otherwise creating the dmabuf wl_buffer will fail (see the wp_linux_buffer_params.create and create_immed requests for details). The main device will also likely be kept active by the compositor, so clients can use it instead of waking up another device for power savings.

In general the device is a DRM node. The DRM node type (primary vs. render) is unspecified. Clients must not rely on the compositor sending a particular node type. Clients cannot check two devices for equality by comparing the dev_t value.

If explicit modifiers are not supported and the client performs buffer allocations on a different device than the main device, then the client must force the buffer to have a linear layout.

Definition at line 5140 of file wayland-server-protocol-unstable.cpp.

  std::function< void()> & zwp_linux_dmabuf_feedback_v1_t::on_destroy ()

destroy the feedback object Using this request a client can tell the server that it is not going to use the wp_linux_dmabuf_feedback object anymore.

Definition at line 5124 of file wayland-server-protocol-unstable.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void zwp_linux_dmabuf_feedback_v1_t::tranche_done (bool post = true)

a preference tranche has been sent This event splits tranche_target_device and tranche_modifier events in preference tranches. It is sent after a set of tranche_target_device and tranche_modifier events; it represents the end of a tranche. The next tranche will have a lower preference.

Definition at line 5145 of file wayland-server-protocol-unstable.cpp.

  void zwp_linux_dmabuf_feedback_v1_t::tranche_flags (zwp_linux_dmabuf_feedback_v1_tranche_flags const & flags, bool post = true)

tranche flags

Parameters
    flags tranche flags

This event sets tranche-specific flags.

The scanout flag is a hint that direct scan-out may be attempted by the compositor on the target device if the client appropriately allocates a buffer. How to allocate a buffer that can be scanned out on the target device is implementation-defined.

This event is tied to a preference tranche, see the tranche_done event.

Definition at line 5160 of file wayland-server-protocol-unstable.cpp.

  void zwp_linux_dmabuf_feedback_v1_t::tranche_formats (array_t const & indices, bool post = true)

supported buffer format modifier

Parameters
    indices array of 16-bit indexes

This event advertises the format + modifier combinations that the compositor supports.

It carries an array of indices, each referring to a format + modifier pair in the last received format table (see the format_table event). Each index is a 16-bit unsigned integer in native endianness.

For legacy support, DRM_FORMAT_MOD_INVALID is an allowed modifier. It indicates that the server can support the format with an implicit modifier. When a buffer has DRM_FORMAT_MOD_INVALID as its modifier, it is as if no explicit modifier is specified. The effective modifier will be derived from the dmabuf.

A compositor that sends valid modifiers and DRM_FORMAT_MOD_INVALID for a given format supports both explicit modifiers and implicit modifiers.

Compositors must not send duplicate format + modifier pairs within the same tranche or across two different tranches with the same target device and flags.

This event is tied to a preference tranche, see the tranche_done event.

For the definition of the format and modifier codes, see the wp_linux_buffer_params.create request.

Definition at line 5155 of file wayland-server-protocol-unstable.cpp.

  void zwp_linux_dmabuf_feedback_v1_t::tranche_target_device (array_t const & device, bool post = true)

target device

Parameters
    device device dev_t value

This event advertises the target device that the server prefers to use for a buffer created given this tranche. The advertised target device may be different for each preference tranche, and may change over time.

There is exactly one target device per tranche.

The target device may be a scan-out device, for example if the compositor prefers to directly scan-out a buffer created given this tranche. The target device may be a rendering device, for example if the compositor prefers to texture from said buffer.

The client can use this hint to allocate the buffer in a way that makes it accessible from the target device, ideally directly. The buffer must still be accessible from the main device, either through direct import or through a potentially more expensive fallback path. If the buffer can't be directly imported from the main device then clients must be prepared for the compositor changing the tranche priority or making wl_buffer creation fail (see the wp_linux_buffer_params.create and create_immed requests for details).

If the device is a DRM node, the DRM node type (primary vs. render) is unspecified. Clients must not rely on the compositor sending a particular node type. Clients cannot check two devices for equality by comparing the dev_t value.

This event is tied to a preference tranche, see the tranche_done event.

Definition at line 5150 of file wayland-server-protocol-unstable.cpp.

Member Data Documentation

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::done_since_version = 1 [static], [constexpr]

Minimum protocol version required for the done function.

Definition at line 2144 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::format_table_since_version = 1 [static], [constexpr]

Minimum protocol version required for the format_table function.

Definition at line 2170 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::main_device_since_version = 1 [static], [constexpr]

Minimum protocol version required for the main_device function.

Definition at line 2204 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::tranche_done_since_version = 1 [static], [constexpr]

Minimum protocol version required for the tranche_done function.

Definition at line 2218 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::tranche_flags_since_version = 1 [static], [constexpr]

Minimum protocol version required for the tranche_flags function.

Definition at line 2309 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::tranche_formats_since_version = 1 [static], [constexpr]

Minimum protocol version required for the tranche_formats function.

Definition at line 2290 of file wayland-server-protocol-unstable.hpp.

  std::uint32_t wayland::server::zwp_linux_dmabuf_feedback_v1_t::tranche_target_device_since_version = 1 [static], [constexpr]

Minimum protocol version required for the tranche_target_device function.

Definition at line 2255 of file wayland-server-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.